using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace WeaponMod
{
    public class WeaponMod
    {
        public static void Main()
        {

           
            //Half Life 2 pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Half Life 2 pistol -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("HL2pistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2pistol.png", 2f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 0.1f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 0.3f;
                        firearm.Cartridge = customCartridge;

firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("HL2pistolFire.wav"),
                ModAPI.LoadSound("HL2pistolFire2.wav"),
                ModAPI.LoadSound("HL2pistolFire3.wav"),
            };

 Instance.FixColliders();


                    }
                }
            );

 //Half Life 2 smg
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "Half Life 2 smg -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("HL2smgView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2smg.png", 1.4f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "5.45x39mm";
                        customCartridge.Damage *= 0.05f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 2f;
                        firearm.Cartridge = customCartridge;

firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("HL2smgFire1.wav"),
 ModAPI.LoadSound("HL2smgFire2.wav"),
 ModAPI.LoadSound("HL2smgFire3.wav"),

            };

 Instance.FixColliders();


                    }
                }
            );

                         //Half Life 2 Crowbar
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), 
                    NameOverride = "Half Life 2 crowbar -HL2", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Gordon Freeman",// Description
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("HL2crowbarView.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2crowbar.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 7f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
							{ModAPI.LoadSound("crowbar.wav")};
                        
                    }
                }
            );

//Half Life 2 SPAS
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "Half Life 2 SPAS-12 -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("HL2SPASView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2SPAS.png", 1.7f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "12-gauge";
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 1f;
                        firearm.Cartridge = customCartridge;

firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("HL2spasFire1.wav"),
 ModAPI.LoadSound("HL2spasFire2.wav"),
 ModAPI.LoadSound("HL2spasFire3.wav"),

            };

 Instance.FixColliders();


                    }
                }
            );

//Half Life 2 357 magnum
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Revolver"),
                    NameOverride = "Half Life 2 357-magnum -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite(".357magnumView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(".357magnum.png", 2f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 1f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 1.5f;
                        firearm.Cartridge = customCartridge;

firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("357_fire2.wav"),
                ModAPI.LoadSound("357_fire3.wav"),
            };

 Instance.FixColliders();


                    }
                }
            );


//Half Life 2 Gravity Gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "Half Life 2 Gravity Gun -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Now kind of works",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("GravityGunView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("GravityGun.png", 1.1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "12-gauge";
                        customCartridge.Damage *= -5f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 1f;
                        firearm.Cartridge = customCartridge;
 firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("phys.wav"),                
            };

                        Instance.FixColliders();


                    }
                }
            );

//Half Life 2 AR2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Half Life 2 AR2 -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("AR2View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AR2.png", 1.2f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "5.45x39mm";
                        customCartridge.Damage *= 0.2f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 0.5f;
                        firearm.Cartridge = customCartridge;

firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("ar1_dist1.wav"),
 ModAPI.LoadSound("ar1_dist2.wav"),


            };

 Instance.FixColliders();


                    }
                }
            );

//HL2 Bolt
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"), 
                    NameOverride = "Half Life 2 Bolt -HL2", // Name.
                    NameToOrderByOverride = "AA2", //  
                    DescriptionOverride = "Gordon Freeman",// Description
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("HL2BoltView.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2Bolt.png", 1f);
 
                    }
                }
            );

 //HL2 Crossbow
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Half Life 2 Crossbow -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("HL2CrossbowView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2Crossbow.png", 1.5f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 10;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Half Life 2 Bolt -HL2");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("ccc.wav");
 
                    }
                }
            );

//Half Life 2 RPG
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rocket Launcher"),
                    NameOverride = "Half Life 2 RPG -HL2",
                    NameToOrderByOverride = "AA1",
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("HL2RocketLauncherView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2RocketLauncher.png", 1.2f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
 var firearm = Instance.GetComponent<RocketLauncherBehaviour>();
                        

                        /*todo: replace rocket*/



                        GameObject Projectile = firearm.Projectile;


                        firearm.AudioSource.clip =  ModAPI.LoadSound("rocketfire1.wav");
 Instance.FixColliders();

                    }
                }
            );

 //HL2 Grenade
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Handgrenade"), 
                    NameOverride = "Half Life 2 Grenade -HL2", 
                    DescriptionOverride = "Gordon Freeman",
                    CategoryOverride = ModAPI.FindCategory("Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("HL2GrenadeView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HL2Grenade.png", 2f);
 Instance.FixColliders();
                    }
                }
            );
        }
    }
}